from django.contrib import admin
from config.models import config, startup, group_vlan
from django.contrib import messages
#
# Per disabilitare l'azione 
# Globally disable delete selected
#admin.site.disable_action('delete_selected')


class EntryConfigAdmin(admin.ModelAdmin):
    list_display = ['modified_date', 'creation_date', 'vlan', 'vlan_description', 'rogue_ra', 'rogue_dhcp', 'spoofed_ip']
    list_editable = ['vlan_description', 'rogue_ra', 'rogue_dhcp', 'spoofed_ip']
    search_fields = ['vlan', 'vlan_description']
    list_per_page = 25

    def __init__(self, *args, **kwargs):
        super(EntryConfigAdmin, self).__init__(*args, **kwargs)
        self.list_display_links = (None, )

    def has_add_permission(self, request):
        return False
		

    def has_delete_permission(self, request, obj=None):
        return False

admin.site.register(config, EntryConfigAdmin)

class EntryStartupAdmin(admin.ModelAdmin):
    list_display = ('modname','attribute','value')
    list_editable = ['value']
    search_fields = ['modname','attribute','value']
    list_per_page = 25

    def __init__(self, *args, **kwargs):
        super(EntryStartupAdmin, self).__init__(*args, **kwargs)
        self.list_display_links = (None, )

    def save_model(self, request, obj, form, change):
        messages.error(request, "Changes will have effect after NDP daemon restart (service ndp restart)")
        super(EntryStartupAdmin, self).save_model(request, obj, form, change)

    def has_add_permission(self, request):
        return False
	
    def has_delete_permission(self, request, obj=None):
        return False
	
admin.site.register(startup, EntryStartupAdmin)
#admin.site.register(Event)


class EntryGroupsVlans(admin.ModelAdmin):
	list_display = ('vlan', 'gr_id')
	fields = ('vlan', 'gr_id')
admin.site.register(group_vlan, EntryGroupsVlans)
