from django.db import models
from datetime import datetime, timedelta
from django.contrib.auth.models import User, Group
from django.db.models.query import QuerySet

class config(models.Model):
        RA_CHOICES = (
                (u'A', u'Mitigate + Notify'),
                (u'M', u'Mitigate'),
                (u'N', u'Notify'),
        )
        DHCP_CHOICES = (
                (u'N', u'Notify'),
        )
        ARP_CHOICES = (
                (u'N', u'Notify'),
        )
	creation_date = models.DateTimeField(auto_now=True, auto_now_add=True)
	modified_date = models.DateTimeField(auto_now=True, auto_now_add=True)
	vlan = models.IntegerField()
	vlan_description = models.CharField(max_length=256, blank=True, null=True, verbose_name="Vlan name")
	rogue_ra = models.CharField(max_length=1, blank=True, null=True, choices=RA_CHOICES, verbose_name="Rogue RA action")
	rogue_dhcp = models.CharField(max_length=1, blank=True, null=True, choices=DHCP_CHOICES, verbose_name="Rogue DHCP action")
	spoofed_ip = models.CharField(max_length=1, blank=True, null=True, choices=ARP_CHOICES, verbose_name="Spoofed IP action")
	
	def __unicode__(self):
		return u'%s' % self.vlan

	class Meta(object):
		verbose_name_plural = "Notification & Mitigation parameters"
                ordering = ('vlan', 'modified_date')

	class Admin:
        	pass


class startup(models.Model):
	modname = models.CharField(max_length=16, null=False, blank=False)
	attribute = models.CharField(max_length=64, null=False, blank=False)
	value = models.CharField(max_length=255, null=False, blank=False)

	class Meta(object):
		verbose_name_plural = "Modules configuration"
	class Admin:
	       	pass

class group_vlan(models.Model):
	vlan = models.ForeignKey(config, verbose_name="Vlan id")
	gr_id = models.ForeignKey(Group, verbose_name="Group name")
	class Meta(object):
		verbose_name_plural = "Group & Vlan configuration"
		unique_together = ('vlan','gr_id')
	class Admin:
	       	pass

