from django.db import models
from datetime import datetime, timedelta
from django.contrib.auth.models import User
from django.db.models.query import QuerySet

class DHCPMon(models.Model):
        DHCP_STATUS = (
                ('L', 'Legal'),
                ('I', 'Illegal'),
        )
        DHCP_MESSAGE_TYPE = (
                (2, 'DHCPOFFER'),
                (6, 'DHCPNAK'),
        )
        creation_date = models.DateTimeField(auto_now=False, auto_now_add=True)
        modified_date = models.DateTimeField(auto_now=False, auto_now_add=True, verbose_name="Last seen")
        mac_src = models.CharField(max_length=17)
        mac_dst = models.CharField(max_length=17)
        vlan = models.SmallIntegerField(blank=True, null=True)
        message_type = models.SmallIntegerField(null=True, choices=DHCP_MESSAGE_TYPE)
        lease_time = models.IntegerField(blank=True, null=True)
        server_id = models.CharField(max_length=15, null=True)

	#non servono#####	
        hostname = models.CharField(max_length=128, null=True)
        renewal_time = models.IntegerField(null=True)
        rebinding_time = models.IntegerField(blank=True, null=True)
	#################

        subnet_mask = models.CharField(max_length=15, null=True)
        router = models.CharField(max_length=15, null=True)
        name_server = models.TextField(null=True)

        counter = models.IntegerField(blank=True, null=True)
        description = models.CharField(max_length=256, blank=True, null=True)
        status = models.CharField(max_length=1, choices=DHCP_STATUS, null=True, blank=True)

	def __unicode__(self):
		return self.mac_src

	class Meta(object):
		verbose_name_plural = "DHCPv4 server detection"
		
                ordering = ('-modified_date', '-creation_date')

	class Admin:
        	pass

