from django.db import models
from datetime import datetime, timedelta
from django.contrib.auth.models import User
from django.db.models.query import QuerySet

class Ipv6NS(models.Model):
	description = models.TextField()
	creation_date = models.DateTimeField(auto_now=True, auto_now_add=True)
	modified_date = models.DateTimeField(auto_now=True, auto_now_add=True, verbose_name="LastSeen")
	mac_src = models.CharField(max_length=50)
	mac_dst = models.CharField(max_length=50)
	vlan = models.IntegerField(blank=True, null=True)
	Counter = models.IntegerField(blank=True, null=True)
	Counter2 = models.IntegerField(blank=True, null=True)
	Commento = models.CharField(max_length=50, verbose_name="hostname")
	ipv6_src = models.CharField(max_length=50)
	ipv6_dst = models.CharField(max_length=50)
	ICMPv6ND_NS_type = models.IntegerField(blank=True, null=True)
	ICMPv6ND_NS_R = models.IntegerField(blank=True, null=True)
	ICMPv6ND_NS_S = models.IntegerField(blank=True, null=True)
	ICMPv6ND_NS_O = models.IntegerField(blank=True, null=True)
	ICMPv6ND_NS_res = models.IntegerField(blank=True, null=True)
	ICMPv6ND_NS_tgt = models.CharField(max_length=50, verbose_name="requested target")
	ICMPv6NDOptSrcLLAddr_type = models.IntegerField(blank=True, null=True)
	ICMPv6NDOptSrcLLAddr_len = models.IntegerField(blank=True, null=True)
	ICMPv6NDOptSrcLLAddr_lladdr = models.CharField(max_length=50, verbose_name="lladdr")
        hostname = models.TextField(blank=True, null=True)
        campo1 = models.TextField(blank=True, null=True)
        campo2 = models.TextField(blank=True, null=True)

	def __unicode__(self):
		return self.mac_src

	class Meta(object):
		verbose_name_plural = "IPv6 Neighbor Solicitation detection"
                ordering = ('-modified_date', '-creation_date')


	class Admin:
        	pass

