from django.contrib import admin
from radiusacc.models import radacct
from django import forms


class MyForm(forms.Form):
        q = forms.CharField(label="", widget=forms.widgets.Textarea(attrs={'cols':75, 'rows':1, 'title': 'Advanced search',}))

class EntryAdmin(admin.ModelAdmin):
        list_display = ['UserName', 'AcctStartTime', 'AcctStopTime', 'AcctSessionId', 'FramedIpAddress', 'CallingStationId', 'CalledStationId', 'AcctTerminateCause', 'Realm', 'NASIPAddress', 'NASPortId', 'AcctSessionTime', 'AcctAuthentic', 'AcctInputOctets', 'AcctOutputOctets']
        list_per_page = 25
        date_hierarchy = 'AcctStartTime'

        def FramedIpAddress(self, obj):
                return '<a href="%s%s">%s</a>' % ('../../nsmon/search?search_string=', obj.FramedIPAddress, obj.FramedIPAddress)
        FramedIpAddress.allow_tags = True
	FramedIpAddress.admin_order_field = 'FramedIPAddress'

	def __init__(self, *args, **kwargs):
                super(EntryAdmin, self).__init__(*args, **kwargs)
                self.list_display_links = (None, )

        def get_actions(self, request):
                actions = super(EntryAdmin, self).get_actions(request)
                if request.user.is_superuser == False:
                        if 'delete_selected' in actions:
                                del actions['delete_selected']
                return actions
	
	def has_add_permission(self, request):
	        return False
        
#	search_fields = ['AcctSessionId', 'FramedIPAddress', 'AcctTerminateCause', 'UserName', 'Realm', 'NASIPAddress', 'NASPortId', 'AcctSessionTime', 'AcctAuthentic', 'AcctInputOctets', 'AcctOutputOctets', 'CallingStationId']

#------------------ADVANCED SEARCH---------------------

        f = MyForm()
        my_clean_data = ""
        my_error = ""
        adv_search = [('UserName', 'UserName'), ('AcctStartTime', 'AcctStartTime'), ('AcctStopTime', 'AcctStopTime'), ('AcctSessionId', 'AcctSessionId'), ('FramedIPAddress', 'FramedIPAddress'), ('CallingStationId','CallingStationId'),('CalledStationId', 'CalledStationId'), ('AcctTerminateCause', 'AcctTerminateCause'), ('Realm', 'Realm'), ('NASIPAddress', 'NASIPAddress'), ('NASPortId', 'NASPortId'), ('AcctSessionTime', 'AcctST'), ('AcctAuthentic', 'AcctAuthentic'), ('AcctInputOctets', 'AcctInputOctets'), ('AcctOutputOctets', 'AcctOutputOctets')]
        def get_advanced_search(self):
                return self.adv_search

        def get_my_data():
                return self.my_clean_data

        def get_my_form(self):
                ff = MyForm(initial={'q':self.my_clean_data})
                return ff

        def get_error(self):
                return self.my_error

        def check_search_string(self, p):
                stopwords = ["INSERT", "DELETE", "TRUNCATE", "SELECT", "DROP", ";"]
                for word in stopwords:
                        if word.lower() in p.lower():
                                return False
                return True

        def set_adv_params(self, request):
                if 'q' in request.GET:
                        f = MyForm(request.GET)
                        if f.is_valid():
                                if self.check_search_string(f.cleaned_data["q"]):
                                        self.my_clean_data = f.cleaned_data["q"]
                                        self.my_error = f.cleaned_data["q"]
                                else:
                                        self.my_clean_data = ""
                                        self.my_error = "Malformed filter"
                        else:
                                self.my_clean_data = ""
                                self.my_error = ""
                else:
                        self.my_clean_data = ""
                        self.my_error = ""

        def queryset(self, request):
                self.my_clean_data = ""
                if request.method == "GET":
                        self.set_adv_params(request)

                myresults = None
                if self.my_clean_data != "":
                        try:
                                self.my_error = ""
                                myresults = radacct.objects.extra(where=[self.my_clean_data])
                        except:
                                self.my_error = "Database error, the search string contains an error"
                                myresults = radacct.objects.all()
                else:
                        myresults = radacct.objects.all()

                return myresults
        #------------------ADVANCED SEARCH---------------------


admin.site.register(radacct, EntryAdmin)
