from django.db import models


class radacct(models.Model):
        RadAcctId = models.BigIntegerField(blank=True, null=True)
        AcctSessionId = models.CharField(max_length=64, blank=True, default="")
        AcctUniqueId = models.CharField(max_length=32, blank=True, default="")
        UserName = models.CharField(max_length=64, blank=True, default="")
        GroupName = models.CharField(max_length=64, blank=True, default="")
        Realm = models.CharField(max_length=64, blank=True, null=True, default="")
        NASIPAddress = models.CharField(max_length=15, blank=True, default="")
        NASPortId = models.CharField(max_length=15, blank=True, null=True)
        NASPortType = models.CharField(max_length=32, blank=True, null=True)
        AcctStartTime = models.DateTimeField(null=True)
        AcctStopTime = models.DateTimeField(null=True)
        AcctSessionTime = models.IntegerField(blank=True, null=True, verbose_name="AcctST")
        AcctAuthentic = models.CharField(max_length=32, blank=True, null=True)
        ConnectInfo_start = models.CharField(max_length=50, blank=True, null=True)
        ConnectInfo_stop = models.CharField(max_length=50, blank=True, null=True)
        AcctInputOctets = models.IntegerField(blank=True, null=True)
        AcctOutputOctets = models.IntegerField(blank=True, null=True)
        CalledStationId = models.CharField(max_length=50, blank=True, default="", verbose_name="CalledStationId")
        CallingStationId = models.CharField(max_length=50, blank=True, default="", verbose_name="CallingStationId")
        AcctTerminateCause = models.CharField(max_length=32, blank=True, default="")
        ServiceType = models.CharField(max_length=32, blank=True, null=True)
        FramedProtocol = models.CharField(max_length=32, blank=True, null=True)
        FramedIPAddress = models.CharField(max_length=15, blank=True, default="")
        AcctStartDelay = models.IntegerField(blank=True, null=True)
        AcctStopDelay = models.IntegerField(blank=True, null=True)
        xascendsessionsvrkey = models.CharField(max_length=10, blank=True, null=True)

        def __unicode__(self):
                return self.NASIPAddress

        class Meta(object):
                verbose_name_plural = "radius accounting"
                ordering = ('-AcctStartTime', '-AcctStopTime')

        class Admin:
                pass


