from django.contrib import admin
from switches.models import switches

class EntryAdmin(admin.ModelAdmin):
	fields = ('IP', 'community', 'enabled', 'version', 'description', 'location')
	list_display = ['IP', 'community', 'version', 'enabled', 'location', 'description', 'modified_date', 'creation_date']
	search_fields = ['IP', 'community', 'version', 'enabled', 'location', 'description'] 
	date_hierarchy = 'modified_date'
	list_per_page = 200
	
	def get_actions(self, request):
                actions = super(EntryAdmin, self).get_actions(request)
                if request.user.is_superuser == False:
                        if 'delete_selected' in actions:
                                del actions['delete_selected']
                return actions



admin.site.register(switches, EntryAdmin)

