from django.contrib import admin
from django.contrib import auth
from django.shortcuts import render_to_response
from django.template import RequestContext
from django.contrib.auth import authenticate, login
from django.contrib.admin.views.decorators import staff_member_required
from django.contrib.auth.decorators import login_required
from django.http import HttpResponse
from django import forms
from django.db import connection, transaction
import random
import json
from macfinddist import start

def dictfetchall(cursor):
	desc = cursor.description
	return [
		dict(zip([col[0] for col in desc], row))
		for row in cursor.fetchall()
	]

def my_custom_sql(uid):
	cursor = connection.cursor()
	mydict = {}
	mylist = []
	try:
		cursor.execute("SELECT * FROM macfind WHERE id = %s ORDER BY status DESC, count ASC", uid)
		rows = cursor.fetchall()
		for r in rows:
			myid = str(r[0]) 
			mydict = {"ip":str(r[1]), "ifname":str(r[2]), "count":int(r[3]), "status":str(r[4]), "description":str(r[7])}
			mylist.append(mydict)
			if mydict["status"] == "AAA":
				cursor.execute("DELETE FROM macfind WHERE id = %s", uid)
				transaction.commit_unless_managed()
	except:
		pass
	return json.dumps(mylist)

@staff_member_required
def macfindresult(request):
	return HttpResponse(my_custom_sql(request.GET['uid']))

class MacFind(forms.Form):
        mac = forms.CharField(label="Insert a MAC address", max_length=17,required=True)

@staff_member_required
def macfind(request):
        if request.method == "GET":
                f = MacFind(request.GET)
                if not f.is_valid():
                        return render_to_response("switches/macfind.html", {"form":f})
                else:
			uid = random.randrange(0, 9999999)
			# 0,1,2,3 debug levels
			mydebug = 1
                        start(uid, f.cleaned_data["mac"], mydebug)
                        context = {
                                'uid': uid,
                                'form':f,
                                'searchedMac':f.cleaned_data["mac"],
                        }
                        return render_to_response (
                                'switches/macfind_result.html',
                                context,
                                context_instance = RequestContext(request, {}),
                        )

        f = MacFind()
        return render_to_response("switches/macfind_result.html", {"form":f}, RequestContext(request, {}),)


