from django.db import models
from datetime import datetime, timedelta
from django.contrib.auth.models import User
from django.db.models.query import QuerySet

class watcharp(models.Model):
	ARP_OP = (
                (1, 'REQUEST'),
                (2, 'REPLY'),
        )
	creation_date = models.DateTimeField(null=True, blank=True, auto_now_add=True)
	modified_date = models.DateTimeField(max_length=50, null=True, blank=True, auto_now_add=True, verbose_name="Last seen")
	counter = models.IntegerField(blank=True, null=True)
	mac_src = models.CharField(max_length=17)
	mac_dst = models.CharField(max_length=17)
	vlan = models.IntegerField(blank=True, null=True)
	hwsrc = models.CharField(max_length=17)
	psrc = models.CharField(max_length=15)
	hwdst = models.CharField(max_length=17)
	pdst = models.CharField(max_length=15)
	ptype = models.IntegerField(blank=True, null=True)
	hwlen = models.IntegerField(blank=True, null=True)
	plen = models.IntegerField(blank=True, null=True)
	hwtype = models.IntegerField(blank=True, null=True)
	op = models.IntegerField(blank=True, null=True, choices=ARP_OP)
	hostname = models.CharField(max_length=256, null=True)
	description = models.TextField(blank=True, default="", null=True)
	creator = models.CharField(max_length=256,blank=True, default="", null=True)

	def __unicode__(self):
		return self.mac_src

	def get_fields(self):
	        return [(field.name, field.verbose_name) for field in watcharp._meta.fields]

	class Meta(object):
		verbose_name_plural = "IPv4 WatchARP"
		ordering = ('-modified_date', '-creation_date')

	class Admin:
        	pass


class ArpConfiguration(models.Model):
	creation_date = models.DateTimeField(null=True, blank=True, auto_now_add=True)
	mac = models.CharField(max_length=17)
	ip = models.IPAddressField()
	vlan = models.IntegerField(null=True)
	description = models.CharField(max_length=256, null=True)

	def __unicode__(self):
		return self.mac

	class Meta(object):
		verbose_name_plural = "Monitored IPv4 addresses"
		ordering = ('-creation_date', 'ip')

	class Admin:
        	pass

